﻿Imports System.Collections.Generic
Imports ShootingGame.DirectGameFramework

Public Class ShootingGame

    Shared Sub Main()
        Dim this As ShootingGame = New ShootingGame()
        this.MainSub()
    End Sub

    Dim i As Integer

    Enum GameMode As Integer
        Title = 0
        Game = 1
        Over = 2
    End Enum

    Dim Game As DirectGameFramework.Main_Render
    Dim Sound As DirectGameFramework.Sound = New DirectGameFramework.Sound
    Dim Input As DirectGameFramework.Input
    Dim move As Vector3
    Dim Vec As Matrix

    Dim Mode As Integer = 0

    Dim MouseX, MouseY, Mouse2X, Mouse2Y As Integer

    Dim EnemyTimer As Timer = New Timer()
    Dim EnemyTimerIV = 1000


    Dim Rand As Random = New Random
    Delegate Sub AlartSub(ByVal str As String, ByVal time As Integer)
    Dim Alart As New AlartSub(AddressOf ViewAlart)
    Dim BulletThr As New ModelSub(AddressOf Shot)


    Dim Score As Result

    Dim Level As Integer = 1
    Dim Mag As Integer = 15
    Dim Fire As Boolean = True

    Dim Mes As String = " , , ,,"
    Dim AlartStr As String
    Dim Life As Integer = 3

    Dim HighScore As Integer
    Dim EnemyThr As New ModelSub(AddressOf EnemySub)

    Dim Model As List(Of DirectGameFramework.Main_Render.Model) = New List(Of Main_Render.Model)
    Dim Enemy As List(Of DirectGameFramework.Main_Render.Model) = New List(Of Main_Render.Model)
    Dim Bullet As List(Of DirectGameFramework.Main_Render.Model) = New List(Of Main_Render.Model)

    Structure Result
        Dim Score As Integer
        Dim Miss As Integer
        Dim Hit As Integer
    End Structure

    Sub MainSub() 'プログラムはここからスタート！

        HighScore = Get_HighScore()

        Game = New Main_Render(1024, 768, "防衛", "img/Load.png")
        Game.Icon = New Icon("img/AIM.ico")
        Game.Cursor = New Cursor("img/AIM.ico")

        Game.Device.RenderState.FogVertexMode = FogMode.Linear
        Game.Device.RenderState.FogStart = 20
        Game.Device.RenderState.FogEnd = 30
        Game.Device.RenderState.FogColor = Color.Gray
        Game.Device.RenderState.FogEnable = True
        Game.Device.Transform.View = Matrix.Identity
        Game.Device.Transform.View = Matrix.LookAtLH(New Vector3(0, 2.5, -16), New Vector3(0, 2.5, 0), New Vector3(0, 1, 0))

        Game.ModelToXFile(Model, "model/back.x", True)
        Game.ModelToXFile(Model, "model/Bomb.x", , , , , , , , 0, 0, 0)
        For i As Integer = 1 To 10
            Game.ModelToXFile(Bullet, "model/bullet.x", True, False, , 2.5, -16)
        Next
        For i As Integer = 1 To 10
            Select Case i Mod 3
                Case 0
                    Game.ModelToXFile(Enemy, "model/Bike.x", True, False, -10, 0.5, , , , , )
                Case 1
                    Game.ModelToXFile(Enemy, "model/Car.x", True, False, -10, 1.2, , , , , )
                Case 2
                    Game.ModelToXFile(Enemy, "model/Jet.x", True, False, -10, Rand.Next(3, 5), , , , , )
                Case Else

            End Select

        Next

        Sound.LoadAudio("sound/M9.wav", , -200)
        Sound.LoadAudio("sound/Reload.wav")
        Sound.LoadAudio("sound/Empty.wav")
        Sound.LoadAudio("sound/BGM.mp3", , -1000)
        Sound.LoadAudio("sound/Empty2.wav")
        Sound.LoadAudio("sound/Brake.wav", , -800)
        Sound.LoadAudio("sound/Clash.wav", , -800)
        Sound.LoadAudio("sound/Over.wav", , )


        Game.CreateTexture("img/Bul.png")
        Game.CreateTexture("img/Title.png")

        Game.CreateFont("ＭＳ ゴシック", 40)
        Game.CreateFont("ＭＳ ゴシック", 100)
        Game.CreateFont("ＭＳ ゴシック", 20)

        Game.Render_Sub = AddressOf Render
        Game.Click_Sub = AddressOf Click
        Game.Key_Sub = AddressOf Key
        Game.SetData_Sub = AddressOf Data

        EnemyTimer.Interval = 1000
        AddHandler EnemyTimer.Tick, AddressOf CreateEnemy
        EnemyTimer.Enabled = False

        AddHandler Sound.Sounds(3).Ending, AddressOf BGMLoop

        Threading.Thread.Sleep(500)

        Game.MainLoop()

    End Sub

    Sub Render()
        Game.Device.BeginScene()

        Game.Device.Clear(ClearFlags.Target Or ClearFlags.ZBuffer, Color.Gray, 1, 0)
        If Mode = GameMode.Title Then
            Game.Sprite.Begin(SpriteFlags.AlphaBlend Or SpriteFlags.SortTexture)

            Game.Sprite.Draw(Game.Textures(1), Rectangle.Empty, Vector3.Empty, New Vector3(0, 0, 0.1), Color.White)
            Game.Fonts(0).DrawText(Game.Sprite, String.Format("HighScore:{0}", HighScore), 570 + 3, 710 + 3, Color.DarkBlue)
            Game.Fonts(0).DrawText(Game.Sprite, String.Format("HighScore:{0}", HighScore), 570, 710, Color.Blue)

            Game.Sprite.End()

        ElseIf Mode = GameMode.Game Then
            Game.RenderModels(Model)
            Game.RenderModels(Enemy)
            Game.RenderModels(Bullet)

            Game.Sprite.Begin(SpriteFlags.AlphaBlend Or SpriteFlags.SortTexture)
            Dim mess() As String = Mes.Split(",")
            Game.Fonts(0).DrawText(Game.Sprite, String.Format("Score:{1} {0}HighScore:{2} {0}Level:{3} ", vbNewLine, Score.Score, HighScore, Level), 0 + 3, 0 + 3, Color.DarkBlue)
            Game.Fonts(0).DrawText(Game.Sprite, String.Format("Score:{1} {0}HighScore:{2} {0}Level:{3} ", vbNewLine, Score.Score, HighScore, Level), 0, 0, Color.Blue)
            Game.Fonts(0).DrawText(Game.Sprite, String.Format("{1} {0}{2} {0}{3} {0}{4} {0}{5} {0}", vbNewLine, mess(mess.Length - 1), mess(mess.Length - 2), mess(mess.Length - 3), mess(mess.Length - 4), mess(mess.Length - 5)), 800 + 3, 0 + 3, Color.DarkBlue)
            Game.Fonts(0).DrawText(Game.Sprite, String.Format("{1} {0}{2} {0}{3} {0}{4} {0}{5} {0}", vbNewLine, mess(mess.Length - 1), mess(mess.Length - 2), mess(mess.Length - 3), mess(mess.Length - 4), mess(mess.Length - 5)), 800, 0, Color.Blue)

            Dim str As String = ""
            For i As Integer = 1 To Life
                str += "♥"
            Next
            Game.Fonts(0).DrawText(Game.Sprite, "LIFE:" & str, 850 + 3, 600 + 3, IIf(Life = 1, Color.DarkRed, Color.DarkBlue))
            Game.Fonts(0).DrawText(Game.Sprite, "LIFE:" & str, 850, 600, IIf(Life = 1, Color.Red, Color.Blue))

            Game.Fonts(0).DrawText(Game.Sprite, "×" & Mag, 930 + 2, 700 + 2, IIf(Mag < 3, Color.DarkRed, Color.DarkBlue))
            Game.Fonts(0).DrawText(Game.Sprite, "×" & Mag, 930, 700, IIf(Mag < 3, Color.Red, Color.Blue))



            Game.Fonts(1).DrawText(Game.Sprite, AlartStr, 350 + 3, 200 + 3, Color.DarkRed)
            Game.Fonts(1).DrawText(Game.Sprite, AlartStr, 350, 200, Color.Red)

            Game.Sprite.Draw(Game.Textures(0), Rectangle.Empty, Vector3.Empty, New Vector3(900, 680, 0), Color.White)

            Game.Sprite.End()

        ElseIf Mode = GameMode.Over Then
            Game.Sprite.Begin(SpriteFlags.AlphaBlend Or SpriteFlags.SortTexture)
            Game.Fonts(1).DrawText(Game.Sprite, "GAMEOVER!", 300 + 3, 200 + 3, Color.DarkRed)
            Game.Fonts(1).DrawText(Game.Sprite, "GAMEOVER!", 300, 200, Color.Red)

            Game.Fonts(0).DrawText(Game.Sprite, String.Format("<<RESULT>> {0}SCORE:{1} {0}Hits:{2} {0}Miss:{3} {0}{0}HighScore:{4}", vbNewLine, Score.Score, Score.Hit, Score.Miss, HighScore), 400 + 3, 400 + 3, Color.DarkBlue)
            Game.Fonts(0).DrawText(Game.Sprite, String.Format("<<RESULT>> {0}SCORE:{1} {0}Hits:{2} {0}Miss:{3} {0}{0}HighScore:{4}", vbNewLine, Score.Score, Score.Hit, Score.Miss, HighScore), 400, 400, Color.Blue)

            Game.Fonts(2).DrawText(Game.Sprite, "Enterキーを押すとタイトル画面に戻ります。" & vbNewLine & "終了する場合は閉じるをクリックしてください。", 550 + 1, 680 + 1, Color.DarkBlue)
            Game.Fonts(2).DrawText(Game.Sprite, "Enterキーを押すとタイトル画面に戻ります。" & vbNewLine & "終了する場合は閉じるをクリックしてください。", 550, 680, Color.Blue)


            If HighScore < Score.Score Then
                Game.Fonts(0).DrawText(Game.Sprite, "NEW RECORD!!", 400 + 3, 700 + 3, Color.DarkOrange)
                Game.Fonts(0).DrawText(Game.Sprite, "NEW RECORD!!", 400, 700, Color.Orange)
            End If
            Game.Sprite.End()
        End If

        Game.Device.EndScene()

        Game.Device.Transform.View = Matrix.LookAtLH(New Vector3(0, 2.5, -16), New Vector3(0, 2.5, 0), New Vector3(0, 1, 0))
        Game.Device.Present()

    End Sub

    Sub Data()
        MouseX = Game.PointToClient(Cursor.Position).X
        MouseY = Game.PointToClient(Cursor.Position).Y
        Mouse2X = MouseX - (Game.ClientSize.Width / 2)
        Mouse2Y = MouseY - (Game.ClientSize.Height / 2)

        Game.Text = i
    End Sub

    Sub Click()
        If Mode = GameMode.Title Then
            Mode = GameMode.Game
            EnemyTimer.Enabled = True
            Sound.Sounds(3).Play()
            
        ElseIf Mode = GameMode.Game Then
            If Mag = 0 Or Not Fire Then
                Sound.Sounds(4).Stop()
                Sound.Sounds(4).Play()
                Exit Sub
            End If

            System.Diagnostics.Debug.WriteLine(Bullet.Count)
            Mag -= 1
            For Each B As Main_Render.Model In Bullet
                If B.Visible Then
                    Continue For
                Else
                    BulletThr.BeginInvoke(B, Nothing, Nothing)
                    Exit Sub
                End If
            Next
            BulletThr.BeginInvoke(Bullet(Game.ModelToXFile(Bullet, "bullet.x", True, False, , 2.5, -16.1, 0, , )), Nothing, Nothing)

        End If


    End Sub

    Sub Key(ByVal e As Windows.Forms.KeyEventArgs)
        If Mode = GameMode.Game Then
            If e.KeyData = Keys.Space Then
                If Not Mag = 15 Then
                    Fire = False
                    Dim Re As New Threading.Thread(AddressOf Reload)
                    Re.Start()
                End If
            End If
        ElseIf Mode = GameMode.Over Then
            If e.KeyData = Keys.Enter Then
                Try
                    Game.Dispose()
                    Sound.Dispose()
                    Application.Restart()
                Catch ex As Exception
                    MsgBox("正常にタイトルへ戻れませんでした。終了します。")
                    Application.Exit()
                End Try
            End If
        End If

    End Sub
    Sub Reload()
        Alart.BeginInvoke("RELOAD!", 800, Nothing, Nothing)
        Sound.Sounds(1).Stop()
        Sound.Sounds(1).Play()

        Threading.Thread.Sleep(800)
        Fire = True
        Mag = 15
    End Sub

    Delegate Sub ModelSub(ByRef M As Main_Render.Model)



    Sub Shot(ByRef Bul As Main_Render.Model)
        System.Diagnostics.Debug.WriteLine(Mag)
        If Bul.Visible = True Then Exit Sub

        Bul.Visible = True
        Bul.Pos = New Vector3(0, 2.5, -16)

        Dim move As Vector3 = New Vector3(0, 0, 2.5)
        Dim Vec As Matrix
        Dim X, Y As Integer
        X = Mouse2X
        Y = Mouse2Y
        If X < 0 Then X = -X
        If Y < 0 Then Y = -Y
        Dim z As Single = Math.Sqrt(X ^ 2 + Y ^ 2)

        Vec.RotateX(Math.Atan2(z, 960))

        move = Vector3.TransformCoordinate(move, Vec)

        Vec = Matrix.Identity
        Vec.RotateZ(-(Math.Atan2(Mouse2Y, Mouse2X)) + (90 * Math.PI / 180))

        move = Vector3.TransformCoordinate(move, Vec)

        Bul.Rotation = New Vector3(Math.Atan2(move.Z, move.Y), Math.Atan2(move.X, move.Z), 0)

        Game.Cursor.Position += New Point(Rand.Next(-6, 6), Rand.Next(-60, -20))

        Sound.Sounds(0).Stop()
        Sound.Sounds(0).Play()
        If Mag = 0 Then
            Alart.BeginInvoke("EMPTY!", 800, Nothing, Nothing)
            Sound.Sounds(2).Stop()
            Sound.Sounds(2).Play()
        End If

        While Bul.Pos.Z < 12

            Bul.Pos += move
            Threading.Thread.Sleep(30)

            If Game.Get_Collide(Model(0), Bul) Then Exit While
            If Bul.Visible = False Then GoTo EBrake

        End While
        Mes += ",MISS!"
        Score.Miss += 1
EBrake:
        Bul.Visible = False
    End Sub


    Sub CreateEnemy()

        EnemyTimer.Interval = EnemyTimerIV
        If EnemyTimerIV < 400 Then
            Level += 1
            Alart.BeginInvoke("LEVEL UP!", 800, Nothing, Nothing)
            EnemyTimerIV = 1000
        End If


        For Each E As Main_Render.Model In Enemy
            If E.Visible Then
                Continue For
            Else
                EnemyThr.BeginInvoke(E, Nothing, Nothing)
                Exit Sub
            End If
        Next

    End Sub

    Sub EnemySub(ByRef Ene As Main_Render.Model)
        If Ene.Visible = True Then Exit Sub
        Ene.Visible = True
        Ene.Pos = New Vector3(Rand.Next(-120, 120) / 10, Ene.Pos.Y, 15)
        Ene.Free = 0
        Dim lev As Integer = Level

        Dim move As Vector3 = New Vector3(0, 0, -lev / 30)
        Dim Vec As Matrix

        Vec = Matrix.Identity
        Vec.RotateY(Ene.Pos.X / 30)

        move = Vector3.TransformCoordinate(move, Vec)


        Ene.Rotation = New Vector3(0, Math.Atan2(move.X, move.Z) + 180 * Math.PI / 180, 0)

        While Ene.Pos.Z > -16

            Ene.Pos += move
            Threading.Thread.Sleep(30)
            For Each B As Main_Render.Model In Bullet
                If Game.Get_Collide(Ene, B) Then

                    B.Visible = False
                    Model(1).Pos = Ene.Pos
                    Model(1).Scaling = New Vector3(0, 0, 0)
                    Model(1).Visible = True
                    Score.Score += 100 * lev
                    EnemyTimerIV -= 25
                    Sound.Sounds(5).Stop()
                    Sound.Sounds(5).Play()
                    While Model(1).Scaling.X < 2
                        Model(1).Scaling += New Vector3(0.05, 0.05, 0.05)
                        Threading.Thread.Sleep(10)
                    End While

                    Model(1).Visible = False
                    Ene.Free = 0
                    Mes += ",BRAKE!"
                    Score.Hit += 1
                    GoTo Brake
                    Exit While
                End If
            Next
        End While

        Alart.BeginInvoke("DAMAGE!", 800, Nothing, Nothing)
        Sound.Sounds(6).Stop()
        Sound.Sounds(6).Play()

        Life -= 1
        If Life = 0 Then
            EnemyTimer.Enabled = False
            Mode = GameMode.Over
            Sound.Sounds(7).Stop()
            Sound.Sounds(7).Play()
            Sound.Sounds(3).Stop()
            If HighScore < Score.Score Then Set_HighScore(Score.Score)
        End If
Brake:

        Ene.Visible = False
    End Sub

    Sub ViewAlart(ByVal str As String, ByVal time As Integer)
        AlartStr = str
        Threading.Thread.Sleep(time)
        AlartStr = ""
    End Sub

    Function Get_HighScore() As Integer
        If Not IO.File.Exists("Score.dat") Then Return 0
        Dim R As IO.StreamReader = New IO.StreamReader("Score.dat")
        Return R.ReadToEnd
        R.Close()
    End Function

    Sub Set_HighScore(ByVal Score As Integer)
        Dim W As IO.StreamWriter = New IO.StreamWriter("Score.dat", False)
        W.WriteLine(Score)
        W.Close()
    End Sub

    Sub BGMLoop()
        Sound.Sounds(3).Stop()
        Sound.Sounds(3).Play()
    End Sub
End Class
